<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
<title>Source code</title>
<link rel="stylesheet" type="text/css" href="../../../../../../stylesheet.css" title="Style">
</head>
<body>
<div class="sourceContainer">
<pre><span class="sourceLineNo">001</span>/**<a name="line.1"></a>
<span class="sourceLineNo">002</span> *<a name="line.2"></a>
<span class="sourceLineNo">003</span> * Licensed to the Apache Software Foundation (ASF) under one or more<a name="line.3"></a>
<span class="sourceLineNo">004</span> * contributor license agreements.  See the NOTICE file distributed with<a name="line.4"></a>
<span class="sourceLineNo">005</span> * this work for additional information regarding copyright ownership.<a name="line.5"></a>
<span class="sourceLineNo">006</span> * The ASF licenses this file to You under the Apache License, Version 2.0<a name="line.6"></a>
<span class="sourceLineNo">007</span> * (the "License"); you may not use this file except in compliance with<a name="line.7"></a>
<span class="sourceLineNo">008</span> * the License.  You may obtain a copy of the License at<a name="line.8"></a>
<span class="sourceLineNo">009</span> *<a name="line.9"></a>
<span class="sourceLineNo">010</span> *     http://www.apache.org/licenses/LICENSE-2.0<a name="line.10"></a>
<span class="sourceLineNo">011</span> *<a name="line.11"></a>
<span class="sourceLineNo">012</span> *  Unless required by applicable law or agreed to in writing, software<a name="line.12"></a>
<span class="sourceLineNo">013</span> *  distributed under the License is distributed on an "AS IS" BASIS,<a name="line.13"></a>
<span class="sourceLineNo">014</span> *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.<a name="line.14"></a>
<span class="sourceLineNo">015</span> *  See the License for the specific language governing permissions and<a name="line.15"></a>
<span class="sourceLineNo">016</span> *  limitations under the License.<a name="line.16"></a>
<span class="sourceLineNo">017</span> */<a name="line.17"></a>
<span class="sourceLineNo">018</span>package org.apache.commons.dbcp2.managed;<a name="line.18"></a>
<span class="sourceLineNo">019</span><a name="line.19"></a>
<span class="sourceLineNo">020</span>import org.apache.commons.dbcp2.ConnectionFactory;<a name="line.20"></a>
<span class="sourceLineNo">021</span><a name="line.21"></a>
<span class="sourceLineNo">022</span>import javax.transaction.TransactionManager;<a name="line.22"></a>
<span class="sourceLineNo">023</span>import javax.transaction.TransactionSynchronizationRegistry;<a name="line.23"></a>
<span class="sourceLineNo">024</span>import javax.transaction.xa.XAException;<a name="line.24"></a>
<span class="sourceLineNo">025</span>import javax.transaction.xa.XAResource;<a name="line.25"></a>
<span class="sourceLineNo">026</span>import javax.transaction.xa.Xid;<a name="line.26"></a>
<span class="sourceLineNo">027</span>import java.sql.Connection;<a name="line.27"></a>
<span class="sourceLineNo">028</span>import java.sql.SQLException;<a name="line.28"></a>
<span class="sourceLineNo">029</span>import java.util.Objects;<a name="line.29"></a>
<span class="sourceLineNo">030</span><a name="line.30"></a>
<span class="sourceLineNo">031</span>/**<a name="line.31"></a>
<span class="sourceLineNo">032</span> * An implementation of XAConnectionFactory which manages non-XA connections in XA transactions. A non-XA connection<a name="line.32"></a>
<span class="sourceLineNo">033</span> * commits and rolls back as part of the XA transaction, but is not recoverable since the connection does not implement<a name="line.33"></a>
<span class="sourceLineNo">034</span> * the 2-phase protocol.<a name="line.34"></a>
<span class="sourceLineNo">035</span> *<a name="line.35"></a>
<span class="sourceLineNo">036</span> * @since 2.0<a name="line.36"></a>
<span class="sourceLineNo">037</span> */<a name="line.37"></a>
<span class="sourceLineNo">038</span>public class LocalXAConnectionFactory implements XAConnectionFactory {<a name="line.38"></a>
<span class="sourceLineNo">039</span>    /**<a name="line.39"></a>
<span class="sourceLineNo">040</span>     * LocalXAResource is a fake XAResource for non-XA connections. When a transaction is started the connection<a name="line.40"></a>
<span class="sourceLineNo">041</span>     * auto-commit is turned off. When the connection is committed or rolled back, the commit or rollback method is<a name="line.41"></a>
<span class="sourceLineNo">042</span>     * called on the connection and then the original auto-commit value is restored.<a name="line.42"></a>
<span class="sourceLineNo">043</span>     * &lt;p&gt;<a name="line.43"></a>
<span class="sourceLineNo">044</span>     * The LocalXAResource also respects the connection read-only setting. If the connection is read-only the commit<a name="line.44"></a>
<span class="sourceLineNo">045</span>     * method will not be called, and the prepare method returns the XA_RDONLY.<a name="line.45"></a>
<span class="sourceLineNo">046</span>     * &lt;/p&gt;<a name="line.46"></a>
<span class="sourceLineNo">047</span>     * It is assumed that the wrapper around a managed connection disables the setAutoCommit(), commit(), rollback() and<a name="line.47"></a>
<span class="sourceLineNo">048</span>     * setReadOnly() methods while a transaction is in progress.<a name="line.48"></a>
<span class="sourceLineNo">049</span>     *<a name="line.49"></a>
<span class="sourceLineNo">050</span>     * @since 2.0<a name="line.50"></a>
<span class="sourceLineNo">051</span>     */<a name="line.51"></a>
<span class="sourceLineNo">052</span>    protected static class LocalXAResource implements XAResource {<a name="line.52"></a>
<span class="sourceLineNo">053</span>        private final Connection connection;<a name="line.53"></a>
<span class="sourceLineNo">054</span>        private Xid currentXid; // @GuardedBy("this")<a name="line.54"></a>
<span class="sourceLineNo">055</span>        private boolean originalAutoCommit; // @GuardedBy("this")<a name="line.55"></a>
<span class="sourceLineNo">056</span><a name="line.56"></a>
<span class="sourceLineNo">057</span>        public LocalXAResource(final Connection localTransaction) {<a name="line.57"></a>
<span class="sourceLineNo">058</span>            this.connection = localTransaction;<a name="line.58"></a>
<span class="sourceLineNo">059</span>        }<a name="line.59"></a>
<span class="sourceLineNo">060</span><a name="line.60"></a>
<span class="sourceLineNo">061</span>        /**<a name="line.61"></a>
<span class="sourceLineNo">062</span>         * Commits the transaction and restores the original auto commit setting.<a name="line.62"></a>
<span class="sourceLineNo">063</span>         *<a name="line.63"></a>
<span class="sourceLineNo">064</span>         * @param xid<a name="line.64"></a>
<span class="sourceLineNo">065</span>         *            the id of the transaction branch for this connection<a name="line.65"></a>
<span class="sourceLineNo">066</span>         * @param flag<a name="line.66"></a>
<span class="sourceLineNo">067</span>         *            ignored<a name="line.67"></a>
<span class="sourceLineNo">068</span>         * @throws XAException<a name="line.68"></a>
<span class="sourceLineNo">069</span>         *             if connection.commit() throws an SQLException<a name="line.69"></a>
<span class="sourceLineNo">070</span>         */<a name="line.70"></a>
<span class="sourceLineNo">071</span>        @Override<a name="line.71"></a>
<span class="sourceLineNo">072</span>        public synchronized void commit(final Xid xid, final boolean flag) throws XAException {<a name="line.72"></a>
<span class="sourceLineNo">073</span>            Objects.requireNonNull(xid, "xid is null");<a name="line.73"></a>
<span class="sourceLineNo">074</span>            if (this.currentXid == null) {<a name="line.74"></a>
<span class="sourceLineNo">075</span>                throw new XAException("There is no current transaction");<a name="line.75"></a>
<span class="sourceLineNo">076</span>            }<a name="line.76"></a>
<span class="sourceLineNo">077</span>            if (!this.currentXid.equals(xid)) {<a name="line.77"></a>
<span class="sourceLineNo">078</span>                throw new XAException("Invalid Xid: expected " + this.currentXid + ", but was " + xid);<a name="line.78"></a>
<span class="sourceLineNo">079</span>            }<a name="line.79"></a>
<span class="sourceLineNo">080</span><a name="line.80"></a>
<span class="sourceLineNo">081</span>            try {<a name="line.81"></a>
<span class="sourceLineNo">082</span>                // make sure the connection isn't already closed<a name="line.82"></a>
<span class="sourceLineNo">083</span>                if (connection.isClosed()) {<a name="line.83"></a>
<span class="sourceLineNo">084</span>                    throw new XAException("Connection is closed");<a name="line.84"></a>
<span class="sourceLineNo">085</span>                }<a name="line.85"></a>
<span class="sourceLineNo">086</span><a name="line.86"></a>
<span class="sourceLineNo">087</span>                // A read only connection should not be committed<a name="line.87"></a>
<span class="sourceLineNo">088</span>                if (!connection.isReadOnly()) {<a name="line.88"></a>
<span class="sourceLineNo">089</span>                    connection.commit();<a name="line.89"></a>
<span class="sourceLineNo">090</span>                }<a name="line.90"></a>
<span class="sourceLineNo">091</span>            } catch (final SQLException e) {<a name="line.91"></a>
<span class="sourceLineNo">092</span>                throw (XAException) new XAException().initCause(e);<a name="line.92"></a>
<span class="sourceLineNo">093</span>            } finally {<a name="line.93"></a>
<span class="sourceLineNo">094</span>                try {<a name="line.94"></a>
<span class="sourceLineNo">095</span>                    connection.setAutoCommit(originalAutoCommit);<a name="line.95"></a>
<span class="sourceLineNo">096</span>                } catch (final SQLException e) {<a name="line.96"></a>
<span class="sourceLineNo">097</span>                    // ignore<a name="line.97"></a>
<span class="sourceLineNo">098</span>                }<a name="line.98"></a>
<span class="sourceLineNo">099</span>                this.currentXid = null;<a name="line.99"></a>
<span class="sourceLineNo">100</span>            }<a name="line.100"></a>
<span class="sourceLineNo">101</span>        }<a name="line.101"></a>
<span class="sourceLineNo">102</span><a name="line.102"></a>
<span class="sourceLineNo">103</span>        /**<a name="line.103"></a>
<span class="sourceLineNo">104</span>         * This method does nothing.<a name="line.104"></a>
<span class="sourceLineNo">105</span>         *<a name="line.105"></a>
<span class="sourceLineNo">106</span>         * @param xid<a name="line.106"></a>
<span class="sourceLineNo">107</span>         *            the id of the transaction branch for this connection<a name="line.107"></a>
<span class="sourceLineNo">108</span>         * @param flag<a name="line.108"></a>
<span class="sourceLineNo">109</span>         *            ignored<a name="line.109"></a>
<span class="sourceLineNo">110</span>         * @throws XAException<a name="line.110"></a>
<span class="sourceLineNo">111</span>         *             if the connection is already enlisted in another transaction<a name="line.111"></a>
<span class="sourceLineNo">112</span>         */<a name="line.112"></a>
<span class="sourceLineNo">113</span>        @Override<a name="line.113"></a>
<span class="sourceLineNo">114</span>        public synchronized void end(final Xid xid, final int flag) throws XAException {<a name="line.114"></a>
<span class="sourceLineNo">115</span>            Objects.requireNonNull(xid, "xid is null");<a name="line.115"></a>
<span class="sourceLineNo">116</span>            if (!this.currentXid.equals(xid)) {<a name="line.116"></a>
<span class="sourceLineNo">117</span>                throw new XAException("Invalid Xid: expected " + this.currentXid + ", but was " + xid);<a name="line.117"></a>
<span class="sourceLineNo">118</span>            }<a name="line.118"></a>
<span class="sourceLineNo">119</span><a name="line.119"></a>
<span class="sourceLineNo">120</span>            // This notification tells us that the application server is done using this<a name="line.120"></a>
<span class="sourceLineNo">121</span>            // connection for the time being. The connection is still associated with an<a name="line.121"></a>
<span class="sourceLineNo">122</span>            // open transaction, so we must still wait for the commit or rollback method<a name="line.122"></a>
<span class="sourceLineNo">123</span>        }<a name="line.123"></a>
<span class="sourceLineNo">124</span><a name="line.124"></a>
<span class="sourceLineNo">125</span>        /**<a name="line.125"></a>
<span class="sourceLineNo">126</span>         * Clears the currently associated transaction if it is the specified xid.<a name="line.126"></a>
<span class="sourceLineNo">127</span>         *<a name="line.127"></a>
<span class="sourceLineNo">128</span>         * @param xid<a name="line.128"></a>
<span class="sourceLineNo">129</span>         *            the id of the transaction to forget<a name="line.129"></a>
<span class="sourceLineNo">130</span>         */<a name="line.130"></a>
<span class="sourceLineNo">131</span>        @Override<a name="line.131"></a>
<span class="sourceLineNo">132</span>        public synchronized void forget(final Xid xid) {<a name="line.132"></a>
<span class="sourceLineNo">133</span>            if (xid != null &amp;&amp; xid.equals(currentXid)) {<a name="line.133"></a>
<span class="sourceLineNo">134</span>                currentXid = null;<a name="line.134"></a>
<span class="sourceLineNo">135</span>            }<a name="line.135"></a>
<span class="sourceLineNo">136</span>        }<a name="line.136"></a>
<span class="sourceLineNo">137</span><a name="line.137"></a>
<span class="sourceLineNo">138</span>        /**<a name="line.138"></a>
<span class="sourceLineNo">139</span>         * Always returns 0 since we have no way to set a transaction timeout on a JDBC connection.<a name="line.139"></a>
<span class="sourceLineNo">140</span>         *<a name="line.140"></a>
<span class="sourceLineNo">141</span>         * @return always 0<a name="line.141"></a>
<span class="sourceLineNo">142</span>         */<a name="line.142"></a>
<span class="sourceLineNo">143</span>        @Override<a name="line.143"></a>
<span class="sourceLineNo">144</span>        public int getTransactionTimeout() {<a name="line.144"></a>
<span class="sourceLineNo">145</span>            return 0;<a name="line.145"></a>
<span class="sourceLineNo">146</span>        }<a name="line.146"></a>
<span class="sourceLineNo">147</span><a name="line.147"></a>
<span class="sourceLineNo">148</span>        /**<a name="line.148"></a>
<span class="sourceLineNo">149</span>         * Gets the current xid of the transaction branch associated with this XAResource.<a name="line.149"></a>
<span class="sourceLineNo">150</span>         *<a name="line.150"></a>
<span class="sourceLineNo">151</span>         * @return the current xid of the transaction branch associated with this XAResource.<a name="line.151"></a>
<span class="sourceLineNo">152</span>         */<a name="line.152"></a>
<span class="sourceLineNo">153</span>        public synchronized Xid getXid() {<a name="line.153"></a>
<span class="sourceLineNo">154</span>            return currentXid;<a name="line.154"></a>
<span class="sourceLineNo">155</span>        }<a name="line.155"></a>
<span class="sourceLineNo">156</span><a name="line.156"></a>
<span class="sourceLineNo">157</span>        /**<a name="line.157"></a>
<span class="sourceLineNo">158</span>         * Returns true if the specified XAResource == this XAResource.<a name="line.158"></a>
<span class="sourceLineNo">159</span>         *<a name="line.159"></a>
<span class="sourceLineNo">160</span>         * @param xaResource<a name="line.160"></a>
<span class="sourceLineNo">161</span>         *            the XAResource to test<a name="line.161"></a>
<span class="sourceLineNo">162</span>         * @return true if the specified XAResource == this XAResource; false otherwise<a name="line.162"></a>
<span class="sourceLineNo">163</span>         */<a name="line.163"></a>
<span class="sourceLineNo">164</span>        @Override<a name="line.164"></a>
<span class="sourceLineNo">165</span>        public boolean isSameRM(final XAResource xaResource) {<a name="line.165"></a>
<span class="sourceLineNo">166</span>            return this == xaResource;<a name="line.166"></a>
<span class="sourceLineNo">167</span>        }<a name="line.167"></a>
<span class="sourceLineNo">168</span><a name="line.168"></a>
<span class="sourceLineNo">169</span>        /**<a name="line.169"></a>
<span class="sourceLineNo">170</span>         * This method does nothing since the LocalXAConnection does not support two-phase-commit. This method will<a name="line.170"></a>
<span class="sourceLineNo">171</span>         * return XAResource.XA_RDONLY if the connection isReadOnly(). This assumes that the physical connection is<a name="line.171"></a>
<span class="sourceLineNo">172</span>         * wrapped with a proxy that prevents an application from changing the read-only flag while enrolled in a<a name="line.172"></a>
<span class="sourceLineNo">173</span>         * transaction.<a name="line.173"></a>
<span class="sourceLineNo">174</span>         *<a name="line.174"></a>
<span class="sourceLineNo">175</span>         * @param xid<a name="line.175"></a>
<span class="sourceLineNo">176</span>         *            the id of the transaction branch for this connection<a name="line.176"></a>
<span class="sourceLineNo">177</span>         * @return XAResource.XA_RDONLY if the connection.isReadOnly(); XAResource.XA_OK otherwise<a name="line.177"></a>
<span class="sourceLineNo">178</span>         */<a name="line.178"></a>
<span class="sourceLineNo">179</span>        @Override<a name="line.179"></a>
<span class="sourceLineNo">180</span>        public synchronized int prepare(final Xid xid) {<a name="line.180"></a>
<span class="sourceLineNo">181</span>            // if the connection is read-only, then the resource is read-only<a name="line.181"></a>
<span class="sourceLineNo">182</span>            // NOTE: this assumes that the outer proxy throws an exception when application code<a name="line.182"></a>
<span class="sourceLineNo">183</span>            // attempts to set this in a transaction<a name="line.183"></a>
<span class="sourceLineNo">184</span>            try {<a name="line.184"></a>
<span class="sourceLineNo">185</span>                if (connection.isReadOnly()) {<a name="line.185"></a>
<span class="sourceLineNo">186</span>                    // update the auto commit flag<a name="line.186"></a>
<span class="sourceLineNo">187</span>                    connection.setAutoCommit(originalAutoCommit);<a name="line.187"></a>
<span class="sourceLineNo">188</span><a name="line.188"></a>
<span class="sourceLineNo">189</span>                    // tell the transaction manager we are read only<a name="line.189"></a>
<span class="sourceLineNo">190</span>                    return XAResource.XA_RDONLY;<a name="line.190"></a>
<span class="sourceLineNo">191</span>                }<a name="line.191"></a>
<span class="sourceLineNo">192</span>            } catch (final SQLException ignored) {<a name="line.192"></a>
<span class="sourceLineNo">193</span>                // no big deal<a name="line.193"></a>
<span class="sourceLineNo">194</span>            }<a name="line.194"></a>
<span class="sourceLineNo">195</span><a name="line.195"></a>
<span class="sourceLineNo">196</span>            // this is a local (one phase) only connection, so we can't prepare<a name="line.196"></a>
<span class="sourceLineNo">197</span>            return XAResource.XA_OK;<a name="line.197"></a>
<span class="sourceLineNo">198</span>        }<a name="line.198"></a>
<span class="sourceLineNo">199</span><a name="line.199"></a>
<span class="sourceLineNo">200</span>        /**<a name="line.200"></a>
<span class="sourceLineNo">201</span>         * Always returns a zero length Xid array. The LocalXAConnectionFactory can not support recovery, so no xids<a name="line.201"></a>
<span class="sourceLineNo">202</span>         * will ever be found.<a name="line.202"></a>
<span class="sourceLineNo">203</span>         *<a name="line.203"></a>
<span class="sourceLineNo">204</span>         * @param flag<a name="line.204"></a>
<span class="sourceLineNo">205</span>         *            ignored since recovery is not supported<a name="line.205"></a>
<span class="sourceLineNo">206</span>         * @return always a zero length Xid array.<a name="line.206"></a>
<span class="sourceLineNo">207</span>         */<a name="line.207"></a>
<span class="sourceLineNo">208</span>        @Override<a name="line.208"></a>
<span class="sourceLineNo">209</span>        public Xid[] recover(final int flag) {<a name="line.209"></a>
<span class="sourceLineNo">210</span>            return new Xid[0];<a name="line.210"></a>
<span class="sourceLineNo">211</span>        }<a name="line.211"></a>
<span class="sourceLineNo">212</span><a name="line.212"></a>
<span class="sourceLineNo">213</span>        /**<a name="line.213"></a>
<span class="sourceLineNo">214</span>         * Rolls back the transaction and restores the original auto commit setting.<a name="line.214"></a>
<span class="sourceLineNo">215</span>         *<a name="line.215"></a>
<span class="sourceLineNo">216</span>         * @param xid<a name="line.216"></a>
<span class="sourceLineNo">217</span>         *            the id of the transaction branch for this connection<a name="line.217"></a>
<span class="sourceLineNo">218</span>         * @throws XAException<a name="line.218"></a>
<span class="sourceLineNo">219</span>         *             if connection.rollback() throws an SQLException<a name="line.219"></a>
<span class="sourceLineNo">220</span>         */<a name="line.220"></a>
<span class="sourceLineNo">221</span>        @Override<a name="line.221"></a>
<span class="sourceLineNo">222</span>        public synchronized void rollback(final Xid xid) throws XAException {<a name="line.222"></a>
<span class="sourceLineNo">223</span>            Objects.requireNonNull(xid, "xid is null");<a name="line.223"></a>
<span class="sourceLineNo">224</span>            if (!this.currentXid.equals(xid)) {<a name="line.224"></a>
<span class="sourceLineNo">225</span>                throw new XAException("Invalid Xid: expected " + this.currentXid + ", but was " + xid);<a name="line.225"></a>
<span class="sourceLineNo">226</span>            }<a name="line.226"></a>
<span class="sourceLineNo">227</span><a name="line.227"></a>
<span class="sourceLineNo">228</span>            try {<a name="line.228"></a>
<span class="sourceLineNo">229</span>                connection.rollback();<a name="line.229"></a>
<span class="sourceLineNo">230</span>            } catch (final SQLException e) {<a name="line.230"></a>
<span class="sourceLineNo">231</span>                throw (XAException) new XAException().initCause(e);<a name="line.231"></a>
<span class="sourceLineNo">232</span>            } finally {<a name="line.232"></a>
<span class="sourceLineNo">233</span>                try {<a name="line.233"></a>
<span class="sourceLineNo">234</span>                    connection.setAutoCommit(originalAutoCommit);<a name="line.234"></a>
<span class="sourceLineNo">235</span>                } catch (final SQLException e) {<a name="line.235"></a>
<span class="sourceLineNo">236</span>                    // Ignore.<a name="line.236"></a>
<span class="sourceLineNo">237</span>                }<a name="line.237"></a>
<span class="sourceLineNo">238</span>                this.currentXid = null;<a name="line.238"></a>
<span class="sourceLineNo">239</span>            }<a name="line.239"></a>
<span class="sourceLineNo">240</span>        }<a name="line.240"></a>
<span class="sourceLineNo">241</span><a name="line.241"></a>
<span class="sourceLineNo">242</span>        /**<a name="line.242"></a>
<span class="sourceLineNo">243</span>         * Always returns false since we have no way to set a transaction timeout on a JDBC connection.<a name="line.243"></a>
<span class="sourceLineNo">244</span>         *<a name="line.244"></a>
<span class="sourceLineNo">245</span>         * @param transactionTimeout<a name="line.245"></a>
<span class="sourceLineNo">246</span>         *            ignored since we have no way to set a transaction timeout on a JDBC connection<a name="line.246"></a>
<span class="sourceLineNo">247</span>         * @return always false<a name="line.247"></a>
<span class="sourceLineNo">248</span>         */<a name="line.248"></a>
<span class="sourceLineNo">249</span>        @Override<a name="line.249"></a>
<span class="sourceLineNo">250</span>        public boolean setTransactionTimeout(final int transactionTimeout) {<a name="line.250"></a>
<span class="sourceLineNo">251</span>            return false;<a name="line.251"></a>
<span class="sourceLineNo">252</span>        }<a name="line.252"></a>
<span class="sourceLineNo">253</span><a name="line.253"></a>
<span class="sourceLineNo">254</span>        /**<a name="line.254"></a>
<span class="sourceLineNo">255</span>         * Signals that a the connection has been enrolled in a transaction. This method saves off the current auto<a name="line.255"></a>
<span class="sourceLineNo">256</span>         * commit flag, and then disables auto commit. The original auto commit setting is restored when the transaction<a name="line.256"></a>
<span class="sourceLineNo">257</span>         * completes.<a name="line.257"></a>
<span class="sourceLineNo">258</span>         *<a name="line.258"></a>
<span class="sourceLineNo">259</span>         * @param xid<a name="line.259"></a>
<span class="sourceLineNo">260</span>         *            the id of the transaction branch for this connection<a name="line.260"></a>
<span class="sourceLineNo">261</span>         * @param flag<a name="line.261"></a>
<span class="sourceLineNo">262</span>         *            either XAResource.TMNOFLAGS or XAResource.TMRESUME<a name="line.262"></a>
<span class="sourceLineNo">263</span>         * @throws XAException<a name="line.263"></a>
<span class="sourceLineNo">264</span>         *             if the connection is already enlisted in another transaction, or if auto-commit could not be<a name="line.264"></a>
<span class="sourceLineNo">265</span>         *             disabled<a name="line.265"></a>
<span class="sourceLineNo">266</span>         */<a name="line.266"></a>
<span class="sourceLineNo">267</span>        @Override<a name="line.267"></a>
<span class="sourceLineNo">268</span>        public synchronized void start(final Xid xid, final int flag) throws XAException {<a name="line.268"></a>
<span class="sourceLineNo">269</span>            if (flag == XAResource.TMNOFLAGS) {<a name="line.269"></a>
<span class="sourceLineNo">270</span>                // first time in this transaction<a name="line.270"></a>
<span class="sourceLineNo">271</span><a name="line.271"></a>
<span class="sourceLineNo">272</span>                // make sure we aren't already in another tx<a name="line.272"></a>
<span class="sourceLineNo">273</span>                if (this.currentXid != null) {<a name="line.273"></a>
<span class="sourceLineNo">274</span>                    throw new XAException("Already enlisted in another transaction with xid " + xid);<a name="line.274"></a>
<span class="sourceLineNo">275</span>                }<a name="line.275"></a>
<span class="sourceLineNo">276</span><a name="line.276"></a>
<span class="sourceLineNo">277</span>                // save off the current auto commit flag so it can be restored after the transaction completes<a name="line.277"></a>
<span class="sourceLineNo">278</span>                try {<a name="line.278"></a>
<span class="sourceLineNo">279</span>                    originalAutoCommit = connection.getAutoCommit();<a name="line.279"></a>
<span class="sourceLineNo">280</span>                } catch (final SQLException ignored) {<a name="line.280"></a>
<span class="sourceLineNo">281</span>                    // no big deal, just assume it was off<a name="line.281"></a>
<span class="sourceLineNo">282</span>                    originalAutoCommit = true;<a name="line.282"></a>
<span class="sourceLineNo">283</span>                }<a name="line.283"></a>
<span class="sourceLineNo">284</span><a name="line.284"></a>
<span class="sourceLineNo">285</span>                // update the auto commit flag<a name="line.285"></a>
<span class="sourceLineNo">286</span>                try {<a name="line.286"></a>
<span class="sourceLineNo">287</span>                    connection.setAutoCommit(false);<a name="line.287"></a>
<span class="sourceLineNo">288</span>                } catch (final SQLException e) {<a name="line.288"></a>
<span class="sourceLineNo">289</span>                    throw (XAException) new XAException("Count not turn off auto commit for a XA transaction")<a name="line.289"></a>
<span class="sourceLineNo">290</span>                            .initCause(e);<a name="line.290"></a>
<span class="sourceLineNo">291</span>                }<a name="line.291"></a>
<span class="sourceLineNo">292</span><a name="line.292"></a>
<span class="sourceLineNo">293</span>                this.currentXid = xid;<a name="line.293"></a>
<span class="sourceLineNo">294</span>            } else if (flag == XAResource.TMRESUME) {<a name="line.294"></a>
<span class="sourceLineNo">295</span>                if (!xid.equals(this.currentXid)) {<a name="line.295"></a>
<span class="sourceLineNo">296</span>                    throw new XAException("Attempting to resume in different transaction: expected " + this.currentXid<a name="line.296"></a>
<span class="sourceLineNo">297</span>                            + ", but was " + xid);<a name="line.297"></a>
<span class="sourceLineNo">298</span>                }<a name="line.298"></a>
<span class="sourceLineNo">299</span>            } else {<a name="line.299"></a>
<span class="sourceLineNo">300</span>                throw new XAException("Unknown start flag " + flag);<a name="line.300"></a>
<span class="sourceLineNo">301</span>            }<a name="line.301"></a>
<span class="sourceLineNo">302</span>        }<a name="line.302"></a>
<span class="sourceLineNo">303</span>    }<a name="line.303"></a>
<span class="sourceLineNo">304</span>    private final TransactionRegistry transactionRegistry;<a name="line.304"></a>
<span class="sourceLineNo">305</span><a name="line.305"></a>
<span class="sourceLineNo">306</span>    private final ConnectionFactory connectionFactory;<a name="line.306"></a>
<span class="sourceLineNo">307</span><a name="line.307"></a>
<span class="sourceLineNo">308</span>    /**<a name="line.308"></a>
<span class="sourceLineNo">309</span>     * Creates an LocalXAConnectionFactory which uses the specified connection factory to create database connections.<a name="line.309"></a>
<span class="sourceLineNo">310</span>     * The connections are enlisted into transactions using the specified transaction manager.<a name="line.310"></a>
<span class="sourceLineNo">311</span>     *<a name="line.311"></a>
<span class="sourceLineNo">312</span>     * @param transactionManager<a name="line.312"></a>
<span class="sourceLineNo">313</span>     *            the transaction manager in which connections will be enlisted<a name="line.313"></a>
<span class="sourceLineNo">314</span>     * @param connectionFactory<a name="line.314"></a>
<span class="sourceLineNo">315</span>     *            the connection factory from which connections will be retrieved<a name="line.315"></a>
<span class="sourceLineNo">316</span>     */<a name="line.316"></a>
<span class="sourceLineNo">317</span>    public LocalXAConnectionFactory(final TransactionManager transactionManager,<a name="line.317"></a>
<span class="sourceLineNo">318</span>            final ConnectionFactory connectionFactory) {<a name="line.318"></a>
<span class="sourceLineNo">319</span>        this(transactionManager, null, connectionFactory);<a name="line.319"></a>
<span class="sourceLineNo">320</span>    }<a name="line.320"></a>
<span class="sourceLineNo">321</span><a name="line.321"></a>
<span class="sourceLineNo">322</span>    /**<a name="line.322"></a>
<span class="sourceLineNo">323</span>     * Creates an LocalXAConnectionFactory which uses the specified connection factory to create database connections.<a name="line.323"></a>
<span class="sourceLineNo">324</span>     * The connections are enlisted into transactions using the specified transaction manager.<a name="line.324"></a>
<span class="sourceLineNo">325</span>     *<a name="line.325"></a>
<span class="sourceLineNo">326</span>     * @param transactionManager<a name="line.326"></a>
<span class="sourceLineNo">327</span>     *            the transaction manager in which connections will be enlisted<a name="line.327"></a>
<span class="sourceLineNo">328</span>     * @param transactionSynchronizationRegistry<a name="line.328"></a>
<span class="sourceLineNo">329</span>     *            the optional TSR to register synchronizations with<a name="line.329"></a>
<span class="sourceLineNo">330</span>     * @param connectionFactory<a name="line.330"></a>
<span class="sourceLineNo">331</span>     *            the connection factory from which connections will be retrieved<a name="line.331"></a>
<span class="sourceLineNo">332</span>     * @since 2.8.0<a name="line.332"></a>
<span class="sourceLineNo">333</span>     */<a name="line.333"></a>
<span class="sourceLineNo">334</span>    public LocalXAConnectionFactory(final TransactionManager transactionManager,<a name="line.334"></a>
<span class="sourceLineNo">335</span>            final TransactionSynchronizationRegistry transactionSynchronizationRegistry,<a name="line.335"></a>
<span class="sourceLineNo">336</span>            final ConnectionFactory connectionFactory) {<a name="line.336"></a>
<span class="sourceLineNo">337</span>        Objects.requireNonNull(transactionManager, "transactionManager is null");<a name="line.337"></a>
<span class="sourceLineNo">338</span>        Objects.requireNonNull(connectionFactory, "connectionFactory is null");<a name="line.338"></a>
<span class="sourceLineNo">339</span>        this.transactionRegistry = new TransactionRegistry(transactionManager, transactionSynchronizationRegistry);<a name="line.339"></a>
<span class="sourceLineNo">340</span>        this.connectionFactory = connectionFactory;<a name="line.340"></a>
<span class="sourceLineNo">341</span>    }<a name="line.341"></a>
<span class="sourceLineNo">342</span><a name="line.342"></a>
<span class="sourceLineNo">343</span>    @Override<a name="line.343"></a>
<span class="sourceLineNo">344</span>    public Connection createConnection() throws SQLException {<a name="line.344"></a>
<span class="sourceLineNo">345</span>        // create a new connection<a name="line.345"></a>
<span class="sourceLineNo">346</span>        final Connection connection = connectionFactory.createConnection();<a name="line.346"></a>
<span class="sourceLineNo">347</span><a name="line.347"></a>
<span class="sourceLineNo">348</span>        // create a XAResource to manage the connection during XA transactions<a name="line.348"></a>
<span class="sourceLineNo">349</span>        final XAResource xaResource = new LocalXAResource(connection);<a name="line.349"></a>
<span class="sourceLineNo">350</span><a name="line.350"></a>
<span class="sourceLineNo">351</span>        // register the xa resource for the connection<a name="line.351"></a>
<span class="sourceLineNo">352</span>        transactionRegistry.registerConnection(connection, xaResource);<a name="line.352"></a>
<span class="sourceLineNo">353</span><a name="line.353"></a>
<span class="sourceLineNo">354</span>        return connection;<a name="line.354"></a>
<span class="sourceLineNo">355</span>    }<a name="line.355"></a>
<span class="sourceLineNo">356</span><a name="line.356"></a>
<span class="sourceLineNo">357</span>    /**<a name="line.357"></a>
<span class="sourceLineNo">358</span>     * @return The connection factory.<a name="line.358"></a>
<span class="sourceLineNo">359</span>     * @since 2.6.0<a name="line.359"></a>
<span class="sourceLineNo">360</span>     */<a name="line.360"></a>
<span class="sourceLineNo">361</span>    public ConnectionFactory getConnectionFactory() {<a name="line.361"></a>
<span class="sourceLineNo">362</span>        return connectionFactory;<a name="line.362"></a>
<span class="sourceLineNo">363</span>    }<a name="line.363"></a>
<span class="sourceLineNo">364</span><a name="line.364"></a>
<span class="sourceLineNo">365</span>    @Override<a name="line.365"></a>
<span class="sourceLineNo">366</span>    public TransactionRegistry getTransactionRegistry() {<a name="line.366"></a>
<span class="sourceLineNo">367</span>        return transactionRegistry;<a name="line.367"></a>
<span class="sourceLineNo">368</span>    }<a name="line.368"></a>
<span class="sourceLineNo">369</span><a name="line.369"></a>
<span class="sourceLineNo">370</span>}<a name="line.370"></a>




























































</pre>
</div>
</body>
</html>
